<%inherit file="dashboard.phtml"/>
<%block name="content">
<p><a href="${url_for('.monit_servers')}">${lang('monit', 'servers', 'Servers')}</a> &gt;&gt; ${server['hostname']}</p>
<h2>${server['hostname']}</h2>
<div class="title">
    ${lang('monit', 'stats', 'Stats')}
</div>
<div class="cont">
    <div class="first_canvas" style="width:100%;" >
        <canvas id="canvas"></canvas>
    </div>
    <div class="other_canvas" style="width:100%;">
        <canvas id="canvas_cpu"></canvas>
    </div>
    <div class="other_canvas" style="width:100%;">
        <canvas id="canvas_mem"></canvas>
    </div>
    <div class="other_canvas" style="width:100%;">
        <canvas id="canvas_disk"></canvas>
    </div>
</div>
<p><a href="">${lang('monit', 'servers', 'Servers')}</a> &gt;&gt; ${server['hostname']}</p>
</%block>
<%block name="jscript_block">
<script language="Javascript" src="${make_media_url('js/jquery.min.js', 'admin')}"></script>
<script language="Javascript" src="${make_media_url('js/Chart.min.js', 'monit')}"></script>
<script>
    
background_out="#28a745";
background_in="#007bff";

var config_net = {
        type: 'line',
        data: {
            labels: [],
            datasets: [{
                label: "In",
                data: [],
                fill: false,
                borderColor: background_in,
                backgroundColor: background_in,
                pointBorderColor: background_in,
                pointBackgroundColor: background_in,
                pointRadius: 0,
                /*pointRadius: 0,
                lineTension: 0.5,*/
                //borderDash: [5, 5],
            }
            ,{
                label: "Out",
                data: [],
                fill: true,
                lineTension: 0.5,
                //borderDash: [5, 5],
                borderColor: background_out,
                backgroundColor: background_out,
                pointBorderColor: background_out,
                pointBackgroundColor: background_out,
                /*pointBorderWidth: 1,*/
                pointRadius: 0
            }]
        },
        options: {
            
            showXLabels: 10,
            animation : false,
            responsive: true,
            legend: {
                position: 'bottom',
            },
            hover: {
                mode: 'label'
            },
            scales: {
                xAxes: [{
                    scaleLabel: {
                        display: true,
                        labelString: 'Time'
                    },
                    ticks: {
                        maxTicksLimit: 8,
                        
                        // Return an empty string to draw the tick line but hide the tick label
                        // Return `null` or `undefined` to hide the tick line entirely
                           userCallback: function(value, index, values) {
                            return value;
                        }
                    }
                }],
                yAxes: [{
                    display: true,
                    scaleLabel: {
                        display: true,
                        labelString: 'KiloBytes'
                    },
                    ticks: {
                        suggestedMax: 500,
                        min: 0
                        
                    }
                }]
            },
            title: {
                display: true,
                text: 'Use of network in this server'
            }
        }
    };
    
    var config_cpu = {
        type: 'line',
        data: {
            labels: [],
            datasets: [{
                label: "CPU idle",
                data: [],
                fill: false,
                borderColor: background_in,
                backgroundColor: background_in,
                pointBorderColor: background_in,
                pointBackgroundColor: background_in,
                pointRadius: 0
                /*pointRadius: 1,
                lineTension: 0.5,*/
                //borderDash: [5, 5],
            }]
        },
        options: {
            showXLabels: 10,
            animation : false,
            responsive: true,
            legend: {
                position: 'bottom',
            },
            hover: {
                mode: 'label'
            },
            scales: {
                xAxes: [{
                    scaleLabel: {
                        display: true,
                        labelString: 'Time'
                    },
                    ticks: {
                        maxTicksLimit: 8,
                        
                        // Return an empty string to draw the tick line but hide the tick label
                        // Return `null` or `undefined` to hide the tick line entirely
                           userCallback: function(value, index, values) {
                            return value;
                        }
                    }
                }],
                yAxes: [{
                    display: true,
                    scaleLabel: {
                        display: true,
                        labelString: 'CPU idle %'
                    },
                    ticks: {
                        max: 100,
                        min: 0
                        
                    }
                }]
            },
            title: {
                display: true,
                text: 'Use of CPU in this server'
            }
        }
    };
    
    var config_mem = {
        type: 'line',
        data: {
            labels: [],
            datasets: [{
                label: "Used",
                data: [],
                fill: false,
                borderColor: '#dd0000',
                backgroundColor: '#dd0000',
                pointBorderColor: '#dd0000',
                pointBackgroundColor: '#dd0000',
                pointRadius: 0,
                /*lineTension: 0.5,*/
                //borderDash: [5, 5],
            }
            ,{
                label: "Free",
                data: [],
                fill: false,
                lineTension: 0.5,
                //borderDash: [5, 5],
                borderColor: background_out,
                backgroundColor: background_out,
                pointBorderColor: background_out,
                pointBackgroundColor: background_out,
                /*pointBorderWidth: 1,*/
                pointRadius: 0
            },
            {
                label: "Cached",
                data: [],
                fill: false,
                lineTension: 0.5,
                //borderDash: [5, 5],
                borderColor: background_in,
                backgroundColor: background_in,
                pointBorderColor: background_in,
                pointBackgroundColor: background_in,
                /*pointBorderWidth: 1,*/
                pointRadius: 0
            }]
        },
        options: {
            showXLabels: 10,
            animation : false,
            responsive: true,
            legend: {
                position: 'bottom',
            },
            hover: {
                mode: 'label'
            },
            scales: {
                xAxes: [{
                    scaleLabel: {
                        display: true,
                        labelString: 'Time'
                    },
                    ticks: {
                        maxTicksLimit: 8,
                        
                        // Return an empty string to draw the tick line but hide the tick label
                        // Return `null` or `undefined` to hide the tick line entirely
                           userCallback: function(value, index, values) {
                            return value;
                        }
                    }
                }],
                yAxes: [{
                    display: true,
                    scaleLabel: {
                        display: true,
                        labelString: 'GigaBytes'
                    },
                    ticks: {
                        //suggestedMax: 500,
                        min: 0
                        
                    }
                }]
            },
            title: {
                display: true,
                text: 'Use of memory in this server'
            }
        }
    };
    
    //Now the disk donut
    
    var config_disk = {
            type: 'bar',
            data: {
                labels: ["/", "/home"],
                datasets: [{
                    label: 'Free space',
                    borderColor: background_in,
                    backgroundColor: background_in,
                    data: [0, 0]
                },
                {
                    label: 'Used space',
                    borderColor: "#dc3545",
                    backgroundColor: "#dc3545",
                    data: [0, 0]
                }]

            },
            options: {
                elements: {
                    rectangle: {
                        borderWidth: 0,
                        borderColor: 'rgb(255, 0, 0)',
                        borderSkipped: 'bottom'
                    }
                },
                hover: {
                    mode: 'label'
                },
                responsive: true,
                legend: {
                    position: 'bottom',
                },
                title: {
                    display: true,
                    text: 'Disk use in GigaBytes'
                },
                animation: {
                    animateScale: true,
                    animateRotate: true
                },
                scales: {
                        yAxes: [{
                        display: true,
                        scaleLabel: {
                            display: true,
                            labelString: 'Gigabytes'
                        },
                        ticks: {
                            
                        }
                    }]
                }
                
            }
        };

    var ctx_disk = document.getElementById("canvas_disk").getContext("2d");
    window.bar_disk = new Chart(ctx_disk, config_disk);
    
    var ctx = document.getElementById("canvas").getContext("2d");
    window.myLine = new Chart(ctx, config_net);
    
    var ctx_cpu = document.getElementById("canvas_cpu").getContext("2d");
    window.myLineCpu = new Chart(ctx_cpu, config_cpu);
    
    var ctx_mem = document.getElementById("canvas_mem").getContext("2d");
    window.myLineMem = new Chart(ctx_mem, config_mem);
    
    window.onload=function () {
        
        update_graph_net();
        update_graph_disk();
        setInterval(update_graph_net, 50000);
        setInterval(update_graph_disk, 100000);
    }
    
    var randomColor = function(opacity) {
        return 'rgba(' + Math.round(Math.random() * 255) + ',' + Math.round(Math.random() * 255) + ',' + Math.round(Math.random() * 255) + ', 1)';
    };
    
    function update_graph_net() {
        
        $.ajax({
        url: "${url_for('.get_net_data', server_id=server['id'])}",
        method: "GET",
        dataType: "json",
        data: {}
        }).done(function(data) {
            
            window.myLine.destroy();
            window.myLineCpu.destroy();
            window.myLineMem.destroy();
            
            config_net.data.labels=[];
            config_net.data.datasets[0].data=[];
            config_net.data.datasets[1].data=[];
            
            config_mem.data.labels=[];
            config_mem.data.datasets[0].data=[];
            config_mem.data.datasets[1].data=[];
            config_mem.data.datasets[2].data=[];
            
            config_cpu.data.labels=[];
            config_cpu.data.datasets[0].data=[];
            
            for(id in data){
                
                //alert(row);
                config_net.data.labels.push(data[id].date);
                config_net.data.datasets[0].data.push(data[id].bytes_recv);
                config_net.data.datasets[1].data.push(data[id].bytes_sent);
                
                config_cpu.data.labels.push(data[id].date);
                config_cpu.data.datasets[0].data.push(data[id].cpu);
                
                config_mem.data.labels.push(data[id].date)
                config_mem.data.datasets[0].data.push(data[id].memory_used);
                config_mem.data.datasets[1].data.push(data[id].memory_free);
                config_mem.data.datasets[2].data.push(data[id].memory_cached);
                
            }
            
            window.myLine = new Chart(ctx, config_net);
            window.myLineCpu = new Chart(ctx_cpu, config_cpu);
            window.myLineMem = new Chart(ctx_mem, config_mem);
            
        }).fail(function (data) {
            
                alert(JSON.stringify(data));
            
        });
        
    };
    
    function update_graph_disk() {
        
        $.ajax({
        url: "${url_for('.get_disk_data', server_id=server['id'])}",
        method: "GET",
        dataType: "json",
        data: {}
        }).done(function(data) {
            
            z=0;
            
            config_disk.data.labels=[]
            
            for(key in data)
            {
                
                config_disk.data.labels.push(data[key]['disk']);
                config_disk.data.datasets[0].data[z]=((((data[key]['free'])/1024)/1024)/1024).toPrecision(2);
                config_disk.data.datasets[1].data[z]=((((data[key]['used'])/1024)/1024)/1024).toPrecision(2);

                z++;
            }
            
            window.bar_disk.destroy();
            
            window.bar_disk = new Chart(ctx_disk, config_disk);
            
        }).fail(function (data) {
            
                alert(JSON.stringify(data));
            
        });
        
    };
    
</script>

</%block>
